#ifndef BASICOBJECTSERIALIZER_H
#define BASICOBJECTSERIALIZER_H

#include "ObjectSerializer.h"
#include "BasicVariant.h"

template<typename T> class ENGINE_API BasicObjectSerializer : public ObjectSerializer
{
public:
	static BasicObjectSerializer& inst()
	{
		static BasicObjectSerializer inst;
		return inst;
	}

	void serialize( const void* p_object,
					SerializationStream& target )
	{
		const T* p_typed = static_cast<const T*>( p_object );
		assert( p_typed );

		// in Stream schreiben
		std::ostringstream text;
		text << *p_typed;
		target.writeString( text.str() );
	}

	Variant* deserialize( const SerializationStream& source )
	{
		// aus Stream lesen
		T object;
		std::istringstream text( source.readString() );
		text >> object;

		return new BasicVariant<T>( object );
	}

private:
	BasicObjectSerializer() : ObjectSerializer( typeid( T ).name() )
	{
	}

	~BasicObjectSerializer()
	{
	}
};

#endif