#ifndef BASICRESOURCEHANDLE_H
#define BASICRESOURCEHANDLE_H

#include "ResourceHandle.h"

template<typename T> class BasicResourceHandle : public ResourceHandle
{
public:
	BasicResourceHandle( T* p_resource = 0 ) : ResourceHandle( p_resource )
	{
	}

	BasicResourceHandle( const BasicResourceHandle& copy ) : ResourceHandle( copy )
	{
	}

	BasicResourceHandle( const ResourceHandle& copy ) : ResourceHandle( copy )
	{
		if( copy )
		{
			// prfen, ob die Ressource auch vom richtigen Typ ist, so dass der Upcast erlaubt ist
			assert( dynamic_cast<const T*>( copy.getResource() ) );
		}
	}

	~BasicResourceHandle()
	{
	}

	operator const T* () const
	{
		return static_cast<const T*>( getResource() );
	}

	operator T* ()
	{
		return static_cast<T*>( getResource() );
	}

	const T* operator * () const
	{
		return static_cast<const T*>( getResource() );
	}

	T* operator * ()
	{
		return static_cast<T*>( getResource() );
	}

	const T* operator -> () const
	{
		return static_cast<const T*>( getResource() );
	}

	T* operator -> ()
	{
		return static_cast<T*>( getResource() );
	}
};

#endif