#ifndef BASICVARIANT_H
#define BASICVARIANT_H

#include "Variant.h"
#include "Serializer.h"

template<typename T> class BasicVariant : public Variant
{
public:
	BasicVariant( const T& value ) : value( value )
	{
	}

	~BasicVariant()
	{
	}

	int serialize( SerializationStream& target ) const
	{
		return Serializer::inst().serialize( value, target );
	}

	Variant* copy() const
	{
		return new BasicVariant( value );
	}

	bool isEqualTo( const Variant* p_other ) const
	{
		const BasicVariant* p_basicOther = dynamic_cast<const BasicVariant*>( p_other );
		if( !p_basicOther ) return false;
		return value == p_basicOther->getValueRef();
	}

	const T& getValueRef() const
	{
		return value;
	}

	T getValue() const
	{
		return value;
	}

private:
	const T value;
};

#endif