#ifndef COMPONENT_H
#define COMPONENT_H

class Engine;
union SDL_Event;

// Basisklasse fr Engine-Komponenten (Video, Audio, Input ...)
class ENGINE_API Component : public Base, public sigslot::has_slots<>
{
public:
	// liefert das Engine-Objekt zurck, zu dem diese Komponente gehrt
	Engine& getEngine() const;

protected:
	Component( Engine& engine, const std::string& componentName );
	virtual ~Component();

private:
	// das Engine-Objekt dieser Komponente
	Engine& engine;

	// Name, mit dem sich die Komponente registriert hat
	const std::string name;
};

#endif