#ifndef LOGHANDLER_H
#define LOGHANDLER_H

enum LogLevel;
class Logger;

class ENGINE_API LogHandler 
{
public:
	LogHandler( Logger& logger );
	virtual ~LogHandler();

	virtual void flush() = 0;

	virtual void log( LogLevel level, const std::string& text, const std::string& filename, unsigned int line ) = 0;

	void disconnect();
	Logger& getLogger() const;

private:
	Logger& logger;
	bool connected;
};

#endif