#ifndef MACROS_H
#define MACROS_H

#define DEFINE_SIGNAL0( SIGNALNAME )																\
	private:																						\
		sigslot::signal0<> sig##SIGNALNAME;															\
	public:																							\
		template<typename T> void connect##SIGNALNAME( T* p_destObject, void ( T::*p_method )() )	\
		{																							\
			sig##SIGNALNAME.connect( p_destObject, p_method );										\
		}

#define DEFINE_SIGNAL1( SIGNALNAME, ARGTYPE1 )																\
	private:																								\
		sigslot::signal1<ARGTYPE1> sig##SIGNALNAME;															\
	public:																									\
		template<typename T> void connect##SIGNALNAME( T* p_destObject, void ( T::*p_method )( ARGTYPE1) )	\
		{																									\
			sig##SIGNALNAME.connect( p_destObject, p_method );												\
		}

#define EMIT_SIGNAL0( SIGNALNAME ) { sig##SIGNALNAME(); }
#define EMIT_SIGNAL1( SIGNALNAME, ARG1 ) { sig##SIGNALNAME( ARG1 ); }

#endif