#ifndef METHODOBJECTSERIALIZER_H
#define METHODOBJECTSERIALIZER_H

#include "ObjectSerializer.h"
#include "BasicVariant.h"

template<typename T> class MethodObjectSerializer : public ObjectSerializer
{
public:
	static MethodObjectSerializer& inst()
	{
		static MethodObjectSerializer inst;
		return inst;
	}

	void serialize( const void* p_object,
					SerializationStream& target )
	{
		const T* p_typed = static_cast<const T*>( p_object );
		assert( p_typed );

		// Methode zum Serialisieren aufrufen
		p_typed->serialize( target );
	}

	Variant* deserialize( const SerializationStream& source )
	{
		// Methode zum Deserialisieren aufrufen
		T object;
		object.deserialize( source );

		return new BasicVariant<T>( object );
	}

private:
	MethodObjectSerializer() : ObjectSerializer( typeid( T ).name() )
	{
	}

	~MethodObjectSerializer()
	{
	}
};

#endif