#ifndef OBJECTSERIALIZER_H
#define OBJECTSERIALIZER_H

#include "SerializationStream.h"

class Variant;

class ENGINE_API ObjectSerializer
{
public:
	virtual void serialize( const void* p_object, SerializationStream& target ) = 0;
	virtual Variant* deserialize( const SerializationStream& source ) = 0;

	void setReadableName( const std::string& readableName );
	const std::string& getReadableName() const;

protected:
	ObjectSerializer( const std::string& type, const std::string& readableName = "" );
	virtual ~ObjectSerializer();

private:
	const std::string type;
	std::string readableName;
};

#endif