#ifndef RESOURCE_H
#define RESOURCE_H

#include "ParameterMap.h"

class ResourceManager;

class ENGINE_API Resource : public Base
{
public:
	// liefert den Referenzzhler
	unsigned int getRefCount() const;

	// erhht den Referenzzhler und liefert dessen neuen Wert
	unsigned int addRef();

	// verringert den Referenzzhler und liefert dessen neuen Wert
	unsigned int release();

	// liefert den Ressourcen-Manager zurck
	const ResourceManager& getManager() const;

	// liefert den Dateinamen zurck
	const std::string& getFilename() const;

	// liefert true, wenn diese Ressource einzigartig ist
	bool isUnique() const;

	// liefert die Optionen zurck
	const ParameterMap& getOptions() const;

protected:
	Resource( ResourceManager& manager, const std::string& filename, bool unique, const ParameterMap& options );
	virtual ~Resource();

private:
	ResourceManager& manager;
	std::string filename;
	bool unique;
	ParameterMap options;
	unsigned int refCount;
};

#endif