#ifndef RESOURCEMANAGER_H
#define RESOURCEMANAGER_H

#include "Component.h"
#include "ResourceHandle.h"
#include "ParameterMap.h"

class Resource;

class ENGINE_API ResourceManager : public Component
{
public:
	ResourceManager( Engine& engine, const std::string& componentName );
	virtual ~ResourceManager();

	// liefert eine Ressource (ldt sie, wenn ntig)
	virtual ResourceHandle get( const std::string& filename, bool unique, const ParameterMap& options ) = 0;

	// lscht und entfernt eine Ressource
	virtual void destroyResource( Resource* p_resource ) = 0;

	// liefert eine Liste mit allen geladenen Ressourcen
	virtual std::list<Resource*> getResources() const = 0;

	// gibt dem Garbage-Collector den Hinweis, dass eine Ressource gelscht werden soll
	void hintGC( Resource* p_resource );

	// lsst den Garbace-Collector laufen
	void runGC();

private:
	void onUpdate();

	std::set<Resource*> gc;
};

#endif