#ifndef SERIALIZATIONSTREAM_H
#define SERIALIZATIONSTREAM_H

class ENGINE_API SerializationStream : public Base
{
public:
	SerializationStream();
	virtual ~SerializationStream();

	// ldt den Stream aus einer Datei
	virtual int load( const std::string& filename ) = 0;

	// schreibt den Stream in eine Datei
	virtual int save( const std::string& filename ) const = 0;

	// erzeugt ein neues Objekt zum Schreiben
	virtual void beginObject( const std::string& type ) = 0;

	// schreibt Text in das aktuelle Objekt
	virtual void writeString( const std::string& text ) = 0;

	// beendet das aktuelle Objekt
	virtual void endObject() = 0;

	// ffnet das nchste Objekt im Stream und liefert dessen Typ oder einen leeren String
	virtual std::string openObject() const = 0;

	// liest Text im aktuellen Objekt
	virtual std::string readString() const = 0;

	// schliet das aktuelle Objekt im Stream
	virtual void closeObject() const = 0;
};

#endif