#ifndef SOUNDCONTROLLERTARGET_H
#define SOUNDCONTROLLERTARGET_H

class Audio;

class ENGINE_API SoundControllerTarget
{
public:
	SoundControllerTarget( Audio& audio );
	~SoundControllerTarget();

	void setStopCountDown( float time );
	void setPauseCountDown( float time );
	void setVolumeTarget( float volume, float speed );
	void setPitchTarget( float pitch, float speed );

	void update();

	virtual int stop() = 0;
	virtual int setPaused( bool paused ) = 0;
	virtual int setVolume( float volume ) = 0;
	virtual int setPitch( float pitch ) = 0;

	virtual float getVolume() const = 0;
	virtual float getPitch() const = 0;

private:
	Audio& audio;
	const float dt;
	float stopCountDown;
	float pauseCountDown;
	float volumeTarget;
	float volumeSpeed;
	float pitchTarget;
	float pitchSpeed;
};

#endif