#ifndef TEXTURE_H
#define TEXTURE_H

#include "Resource.h"
#include "BasicResourceManager.h"
#include "BasicResourceHandle.h"

struct SDL_Surface;

class ENGINE_API Texture : public Resource
{
	friend class TextureManager;
	friend class BasicResourceManager<Texture>;
	friend class Video;

public:
	// liefert die Gre der Textur
	const Vec2i& getSize() const;

private:
	Texture( ResourceManager& manager, const std::string& filename, bool unique, const ParameterMap& options );
	Texture( ResourceManager& manager, const Vec2i& size, int glFormat );
	~Texture();

	void activate();
	void prepareForBitmapFont();

	unsigned int texID;
	SDL_Surface* p_surface;
	Vec2i size;
	float matrix[16];
};

typedef BasicResourceHandle<Texture> TextureHandle;

#endif