#ifndef XMLSERIALIZATIONSTREAM_H
#define XMLSERIALIZATIONSTREAM_H

#include "SerializationStream.h"

class TiXmlDocument;
class TiXmlElement;

class ENGINE_API XMLSerializationStream : public SerializationStream
{
public:
	XMLSerializationStream();
	XMLSerializationStream( const std::string& filename );
	~XMLSerializationStream();

	int load( const std::string& filename );
	int save( const std::string& filename ) const;

	void beginObject( const std::string& type );
	void writeString( const std::string& text );
	void endObject();

	std::string openObject() const;
	std::string readString() const;
	void closeObject() const;

private:
	TiXmlDocument* p_doc;
	mutable TiXmlElement* p_elem;
};

#endif