#include <PCH.h>
#include <Component.h>
#include <Engine.h>

Component::Component( Engine& engine,
					  const std::string& componentName ) : engine( engine ),
														   name( componentName )
{
	engine.registerComponent( componentName, this );
}

Component::~Component()
{
	engine.unregisterComponent( name );
}

Engine& Component::getEngine() const
{
	return engine;
}