#include <PCH.h>
#include <ConsoleLogHandler.h>
#include <Logger.h>
#include <Utils.h>

ConsoleLogHandler::ConsoleLogHandler( Logger& logger ) : LogHandler( logger )
{
}

ConsoleLogHandler::~ConsoleLogHandler()
{
}

void ConsoleLogHandler::flush()
{
	std::cout << std::flush;
}

void ConsoleLogHandler::log( LogLevel level,
							 const std::string& text,
							 const std::string& filename,
							 unsigned int line )
{
	static const char* p_caption[LL_MAX_VALUE] = { "ERROR", "WARNING", "INFO", "FINE", "FINER", "FINEST" };

	// TODO: Datumsformat hinzufgen.
	std::cout << p_caption[level] << ": " << text << " (" << getPathFilename( filename ) << ":" << line << ")" << std::endl;
}