#include <PCH.h>
#include <GameState.h>
#include <Engine.h>

GameState::GameState( Engine& engine,
					  const std::string& stateName) : engine( engine ),
													  logger( engine.getLogger() ),
													  video( engine.getVideo() ),
													  audio( engine.getAudio() ),
													  input( engine.getInput() ),
													  name( stateName )
{
	engine.registerGameState( stateName, this );
}

GameState::~GameState()
{
	engine.unregisterGameState( name );
}

Engine& GameState::getEngine() const
{
	return engine;
}

void GameState::onEnter( const ParameterMap& params )
{
}

void GameState::onLeave()
{
}

void GameState::onActivate()
{
}

void GameState::onDeactivate()
{
}

void GameState::update()
{
}

void GameState::render()
{
}