#include <PCH.h>
#include <LogHandler.h>
#include <Logger.h>

LogHandler::LogHandler( Logger& logger ) : logger( logger ),
										   connected( true )
{
	logger.addLogHandler( this );
	connected = true;
}

LogHandler::~LogHandler()
{
	if( connected ) disconnect();
}

void LogHandler::disconnect()
{
	if( connected )
	{
		logger.removeLogHandler( this );
		connected = false;
	}
}

Logger& LogHandler::getLogger() const
{
	return logger;
}