#include <PCH.h>
#include <ObjectSerializer.h>
#include <Serializer.h>

ObjectSerializer::ObjectSerializer( const std::string& type,
								    const std::string& readableName ) : type( type )
{
	Serializer::inst().registerObjectSerializer( type, this );
	setReadableName( readableName.empty() ? type : readableName );
}

ObjectSerializer::~ObjectSerializer()
{
}

void ObjectSerializer::setReadableName( const std::string& readableName )
{
	this->readableName = readableName;
	if( readableName != type ) Serializer::inst().setReadableName( type, readableName );
}

const std::string& ObjectSerializer::getReadableName() const
{
	return readableName;
}