#include <PCH.h>
#include <ResourceHandle.h>
#include <Resource.h>

ResourceHandle::ResourceHandle( Resource* p_resource ) : p_resource( p_resource )
{
	if( p_resource ) p_resource->addRef();
}

ResourceHandle::ResourceHandle( const ResourceHandle& copy )
{
	p_resource = copy.p_resource;
	if( p_resource ) p_resource->addRef();
}

ResourceHandle::~ResourceHandle()
{
	if( p_resource ) p_resource->release();
}

void ResourceHandle::reset()
{
	if( p_resource ) p_resource->release();
	p_resource = 0;
}

ResourceHandle::operator bool () const
{
	return p_resource ? true : false;
}

ResourceHandle& ResourceHandle::operator = ( const ResourceHandle& rhs )
{
	if( p_resource != rhs.p_resource )
	{
		if( p_resource ) p_resource->release();
		if( rhs.p_resource ) rhs.p_resource->addRef();
		p_resource = rhs.p_resource;
	}

	return *this;
}

bool ResourceHandle::operator == ( const ResourceHandle& rhs ) const
{
	return p_resource == rhs.p_resource;
}

bool ResourceHandle::operator != ( const ResourceHandle& rhs ) const
{
	return p_resource != rhs.p_resource;
}

bool ResourceHandle::operator < ( const ResourceHandle& rhs ) const
{
	return p_resource < rhs.p_resource;
}

const Resource* ResourceHandle::getResource() const
{
	return p_resource;
}

Resource* ResourceHandle::getResource()
{
	return p_resource;
}