#include <PCH.h>
#include <SoundManager.h>
#include <Engine.h>

SoundManager::SoundManager( Engine& engine,
						    const std::string& componentName ) : BasicResourceManager<Sound>( engine, componentName )
{
	engine.connectEngineShutDown( this, &SoundManager::onEngineShutDown );
	engine.connectUpdate( this, &SoundManager::onUpdate );
}

SoundManager::~SoundManager()
{
}

void SoundManager::onEngineShutDown()
{
	// alle Instanzen stoppen
	const std::multimap<std::string, Sound*>& resources = getResourcesMap();
	for( std::multimap<std::string, Sound*>::const_iterator it = resources.begin();
		 it != resources.end();
		 it++ )
	{
		it->second->destroyAll();
	}
}

void SoundManager::onUpdate()
{
	// bei allen Sound-Objekten die update-Methode aufrufen
	const std::multimap<std::string, Sound*>& resources = getResourcesMap();
	for( std::multimap<std::string, Sound*>::const_iterator it = resources.begin();
		 it != resources.end();
		 it++ )
	{
		it->second->update();
	}
}