#include <PCH.h>
#include <TextureManager.h>
#include <Engine.h>

TextureManager::TextureManager( Engine& engine,
								const std::string& componentName ) : BasicResourceManager<Texture>( engine, componentName )
{
}

TextureManager::~TextureManager()
{
}

TextureHandle TextureManager::createTexture( const Vec2i& size,
											 int glFormat )
{
	Texture* p_texture = new Texture( *this, size, glFormat );
	if( p_texture->getError() ) return 0;

	addResource( p_texture );

	return TextureHandle( p_texture );
}