#ifndef ARMED_H
#define ARMED_H

class GameObject;
class Obj_Projectile;

enum WeaponType
{
	// Spieler-Waffen
	WT_INK_BLASTER,
	WT_MISSILE,
	WT_CANNON,
	WT_AUTO_GUN,

	WT_LAST_PLAYER,

	// Gegner-Waffen
	WT_INK_BLASTER_2,
	WT_AA,

	WT_LAST
};

struct WeaponInfo
{
	bool initialized;
	Vec2f relPosition;
	unsigned int ammo;
	int projectileType;
	float speed;
	float calcSpeed;
	float speedVar;
	float deviation;
	float reloadTime;
	bool showTrajectory;
	float trajectoryFriction;
	SoundHandle fireSound;
	float fireSoundVolume;
	float fireSoundVolumeVar;
	float fireSoundPitch;
	float fireSoundPitchVar;
	Placeable* p_parent;
};

class Armed
{
public:
	Armed( GameEnvironment& env );
	virtual ~Armed();

	void updateArmed();

	Obj_Projectile* fire( const Vec2f& direction, bool absDir = false );
	Obj_Projectile* fireAt( GameObject* p_target );

	void selectWeapon( WeaponType weapon );

	void setupWeapon( WeaponType weapon, const Vec2f& relPosition = Vec2f( 0.0f, 0.0f ), Placeable* p_parent = 0 );
	void setupWeapon_lua( WeaponType weapon, const Vec2f& relPosition ) { setupWeapon( weapon, relPosition ); }

	WeaponType getCurrentWeapon() const;
	const WeaponInfo* getWeapons() const;

	void addAmmo( WeaponType weapon, unsigned int value );
	void setAmmo( WeaponType weapon, unsigned int value );
	unsigned int getAmmo( WeaponType weapon ) const;

protected:
	Placeable* p_defaultWeaponParent;

private:
	GameEnvironment& armedEnv;
	WeaponType currentWeapon;
	WeaponInfo weapon[WT_LAST];
	float reload;
};

#endif