#ifndef CAMPAIGN_H
#define CAMPAIGN_H

class Campaign : public Base
{
public:
	Campaign( const std::string& filename );
	~Campaign();

	const std::string& getFilename() const;
	const std::string& getName() const;
	unsigned int getNumUnlockedLevels() const;
	const std::vector<std::string>& getLevels() const;
	bool isLevelUnlocked( const std::string& level ) const;
	unsigned int getNumLevelsCompleted() const;

private:
	const std::string filename;
	std::string name;
	unsigned int numUnlockedLevels;
	std::vector<std::string> levels;
};

#endif