#ifndef GS_CONFIG
#define GS_CONFIG

class GS_Config : public GameState
{
public:
	GS_Config( Engine& engine, GUI& gui, ParameterMap& config, const ParameterMap& defaultConfig );
	~GS_Config();

	void onEnter( const ParameterMap& params );
	void onLeave();
	void onActivate();
	void onDeactivate();
	void update();
	void render();

private:
	bool handleConfig( const CEGUI::EventArgs& e );
	void updateScreen();
	void updateActivation();
	void updateConfig();

	GUI& gui;
	ParameterMap& config;
	ParameterMap defaultConfig;
	TextureHandle logo;
	unsigned int time;
};

#endif