#ifndef GS_GAME_H
#define GS_GAME_H

class Level;
class GameObject;
class Obj_PlayerGhost;

class GS_Game : public GameState
{
public:
	GS_Game( GameEnvironment& env );
	~GS_Game();

	void onEnter( const ParameterMap& params );
	void onLeave();
	void onActivate();
	void onDeactivate();
	void update();
	void render();

private:
	void loadLevel( std::string level );
	void renderHUD();
	void renderPhysicsView();
	void renderStatistics();

	bool handleInGameMenu( const CEGUI::EventArgs& e );
	bool handleLevelCompleted( const CEGUI::EventArgs& e );
	void showHighscores();

	std::string getNextLevel( const std::string& currentLevel, const std::string& campaign ) const;

	GameEnvironment& env;
	unsigned int time;
	std::string currentLevel;
	std::string currentCampaign;
	Level* p_level;
	Obj_PlayerGhost* p_replayGhost;
	Obj_PlayerGhost* p_recordGhost;
	TextureHandle hud;
	TextureHandle icons;
	SoundHandle countDownSound;
	SoundInstance* p_countDownSoundInst;
	float healthDisplay;
	float fuelDisplay;
	float oldHealth;
	Vec2f smileyOffset;
	float motionBlurring;
	bool dialogShown;
	bool raceMode;
	float raceCountDown;
	int levelTry;
	Vec2f lastPlayerPos;
	Vec2f lastPlayerVelocity;
	float lastPlayerAngle;
	float lastPlayerAngularVelocity;
	float lastPlayerHealth;
	CEGUI::String lastName;
	float rebirthCountDown;
	GameObject* p_rebirthCheckpoint;

	bool paused;
	bool optionShowPhysics;
	bool optionShowStatistics;
	bool optionSlowMotion;
	bool optionMoveCamera;
	Vec2f camera;
	float cameraZoom;
};

#endif