#ifndef GS_MENU
#define GS_MENU

class GS_Menu : public GameState
{
public:
	GS_Menu( GameEnvironment& env );
	~GS_Menu();

	void onEnter( const ParameterMap& params );
	void onLeave();
	void onActivate();
	void onDeactivate();
	void update();
	void render();

private:
	bool handleMainMenu( const CEGUI::EventArgs& e );
	bool handleLevelSelection( const CEGUI::EventArgs& e );
	void listCampaigns( bool keepSelection = true );
	void listLevels( bool keepSelection = true );
	void displayLevel();
	void resetHighscores();

	GameEnvironment& env;
	std::vector<TextureHandle> images;
	TextureHandle logo;
	TextureHandle paper;
	float logoX;
};

#endif