#ifndef GS_TESTARENA_H
#define GS_TESTARENA_H

class Level;
class Controllable;
class GameObject;
class Obj_TestTarget;

class GS_TestArena : public GameState
{
public:
	GS_TestArena( GameEnvironment& env );
	~GS_TestArena();

	void onEnter( const ParameterMap& params );
	void onLeave();
	void onActivate();
	void onDeactivate();
	void update();
	void render();

private:
	void setup();
	void evaluate();
	void cleanUp();

	GameEnvironment& env;
	std::string mode;
	Level* p_level;
	Controllable* p_candidate;
	GameObject* p_candidateObj;
	Obj_TestTarget* p_testTarget;
	std::string candidateBehavior;
	std::string baseNetFilename;
	std::vector<NeuralNetHandle> population;
	unsigned int startPopulation;
	unsigned int maxPopulation;
	unsigned int currentNet;
	unsigned int currentPass;
	unsigned int numPasses;
	unsigned int time;
	float currentScore;
};

#endif