#ifndef GUI_H
#define GUI_H

#include <CEGUI/CEGUI.h>

#define SUBSCRIBE_GUI_EVENT( WINDOW, EVENT, METHOD )										\
{																							\
	CEGUI::Window* p_wnd = CEGUI::WindowManager::getSingleton().getWindow( ( WINDOW ) );	\
	if( p_wnd )																				\
	{																						\
		p_wnd->subscribeEvent( ( EVENT ), CEGUI::SubscriberSlot( ( METHOD ), this ) );		\
	}																						\
}

namespace CEGUI
{
	class OpenGLRenderer;
}

class GUI : public Component
{
public:
	GUI( Engine& engine );
	~GUI();

	void loadLayout( const std::string& filename, const std::string& parent = "Root" );
	CEGUI::WindowManager& getWindowManager() const;
	CEGUI::Window* getWindow( const std::string& name ) const;
	CEGUI::Window* getRoot() const;
	void showAndFocusWindow( const std::string& name );
	bool areWindowsVisible( const CEGUI::Window* p_window = 0 ) const;

private:
	void onPostRender();
	void onSDLEvent( const SDL_Event& e );
	void onUpdate();

	CEGUI::System* p_system;
	CEGUI::OpenGLRenderer* p_renderer;
	CEGUI::Window* p_root;
};

#endif