#ifndef NEURALNET_H
#define NEURALNET_H

struct fann;

class NeuralNet : public Resource
{
	friend class BasicResourceManager<NeuralNet>;

public:
	// liefert die Anzahl der Eingnge
	unsigned int getNumInputs() const;

	// liefert die Anzahl der Ausgnge
	unsigned int getNumOutputs() const;

	// liefert die Anzahl der Neuronen
	unsigned int getNumNeurons() const;

	// liefert die Anzahl der Verbindungen
	unsigned int getNumConnections() const;

	// berechnet die Ausgabe fr eine Eingabe
	float* run( float* p_input );

private:
	NeuralNet( ResourceManager& manager, const std::string& filename, bool unique, const ParameterMap& options );
	~NeuralNet();

	fann* p_fann;
};

typedef BasicResourceManager<NeuralNet> NeuralNetManager;
typedef BasicResourceHandle<NeuralNet> NeuralNetHandle;

#endif