#ifndef OBJ_ACCELERATOR_H
#define OBJ_ACCELERATOR_H

#include "GameObject.h"

class Obj_Accelerator : public GameObject
{
public:
	Obj_Accelerator( Level& level, const TiXmlElement* p_root );
	~Obj_Accelerator();

	std::string getType() const { return "Accelerator"; }

	void update();
	void render( RenderPass pass );
	void onCollision( GameObject* p_other, CollisionInfo& info );

	float getRadius() const { return radius; }
	float getTargetSpeed() const { return targetSpeed; }
	void setTargetSpeed( float v ) { targetSpeed = v; }
	float getStrength() const { return strength; }
	void setStrength( float v ) { strength = v; }
	bool isActivated() const { return activated; }
	void setActivated( bool v ) { activated = v; }

private:
	float radius;
	float targetSpeed;
	float strength;
	float active;
	bool activated;
	SoundHandle sound;
	std::set<GameObject*> lastObjectsOnMe;
	std::set<GameObject*> currentObjectsOnMe;
};

#endif