#ifndef OBJ_CHECKPOINT_H
#define OBJ_CHECKPOINT_H

#include "GameObject.h"

class Obj_Checkpoint : public GameObject
{
public:
	Obj_Checkpoint( Level& level, const TiXmlElement* p_root );
	~Obj_Checkpoint();

	std::string getType() const { return "Checkpoint"; }

	void update();
	void render( RenderPass pass );
	void onCollision( GameObject* p_other, CollisionInfo& info );

	void setActivated( bool v ) { activated = v; }
	bool isActivated() const { return activated; }
	void setActivationTime( float v ) { activationTime = v; }
	float getActivationTime() const { return activationTime; }
	void setNumber( unsigned int v ) { number = v; }
	unsigned int getNumber() const { return number; }
	void setShieldDuration( float v ) { shieldDuration = v; }
	float getShieldDuration() const { return shieldDuration; }
	void setHealthAmount( float v ) { healthAmount = v; }
	float getHealthAmount() const { return healthAmount; }
	void setFuelAmount( float v ) { fuelAmount = v; }
	float getFuelAmount() const { return fuelAmount; }

private:
	SoundHandle sound;
	SoundHandle neonSound;
	SoundInstance* p_neonSoundInst;
	float flash;
	bool activated;
	float activationTime;
	unsigned int number;
	float shieldDuration;
	float healthAmount;
	float fuelAmount;
};

#endif