#ifndef OBJ_ENEMY_H
#define OBJ_ENEMY_H

#include "GameObject.h"
#include "Controllable.h"
#include "Damagable.h"
#include "Armed.h"

enum EnemyState
{
	ES_READY,
	ES_AVOID,
	ES_CHASE_TARGET,
	ES_FOLLOW_PATH,
	ES_FREE,

	ES_LAST
};

enum EnemyPathMode
{
	EPM_ONCE = 0,
	EPM_LOOP = 1,
	EPM_PING_PONG = 2,

	EPM_LAST
};

class Obj_Enemy : public GameObject, public Controllable, public Damagable, public Armed
{
public:
	Obj_Enemy( Level& level, const TiXmlElement* p_root, bool createBody );
	virtual ~Obj_Enemy();

	virtual void update();
	virtual void render( RenderPass pass );
	virtual void generateInput();
	virtual void think();

protected:
	EnemyState state;
	Vec2i texCoords;
	Vec2i sizeOnTexture;
	float scaling;
	float range;
	std::vector<std::string> path;
	int currentWaypoint;
	int pathDir;
	EnemyPathMode pathMode;
	float waiting;
	float avoidanceRadius;

	Vec2f movementTargetPosition;
	Vec2f movementTargetVelocity;
	Vec2f oldPosition;
	float moved;
	float movementCheckTimer;
};

#endif