#ifndef OBJ_GARAGE_H
#define OBJ_GARAGE_H

#include "GameObject.h"

class Obj_Garage : public GameObject
{
public:
	Obj_Garage( Level& level, const TiXmlElement* p_root );
	~Obj_Garage();

	std::string getType() const { return "Garage"; }

	void update();
	void render( RenderPass pass );

	void setRepairCapacity( float v ) { repairLeft = v; }
	float getRepairCapacity() const { return repairLeft; }
	void setRefuelCapacity( float v ) { fuelLeft = v; }
	float getRefuelCapacity() const { return fuelLeft; }
	void setRepairPrice( float v ) { repairPrice = v; }
	float getRepairPrice() const { return repairPrice; }
	void setRefuelPrice( float v ) { fuelPrice = v; }
	float getRefuelPrice() const { return fuelPrice; }

private:
	SimpleEmitter* p_emitter;
	SoundHandle sound;
	SoundHandle neonSound;
	SoundInstance* p_soundInst;
	SoundInstance* p_neonSoundInst;
	float reload;
	float repairPrice;
	float fuelPrice;
	float repairLeft;
	float fuelLeft;
	float flash;
	bool release;
};

#endif