#ifndef OBJ_LASER_H
#define OBJ_LASER_H

#include "GameObject.h"

class Damagable;

class Obj_Laser : public GameObject
{
public:
	Obj_Laser( Level& level, const TiXmlElement* p_root );
	~Obj_Laser();

	std::string getType() const { return "Laser"; }

	void update();
	void render( RenderPass pass );
	void addAvoidanceAreas();
	void onKill();
	void onRebirth();

	void setActive( bool active );
	bool isActive() const;
	bool isPowered() const;

private:
	void updateSound();

	bool dynamic;
	bool active;
	size_t numEnergyNodesAlive;
	std::set<std::string> energyNodeIDs;
	std::vector<Vec2f> beam;
	std::set<Damagable*> lastHitObjects;
	std::set<Damagable*> currentHitObjects;
	SoundInstance* p_soundInst;
};

#endif