#ifndef OBJ_PLAYERGHOST_H
#define OBJ_PLAYERGHOST_H

#include "GameObject.h"

class Obj_PlayerGhost : public GameObject
{
public:
	Obj_PlayerGhost( Level& level, const std::string& filename, bool record );
	~Obj_PlayerGhost();

	std::string getType() const { return "PlayerGhost"; }

	void update();
	void render( RenderPass pass );
	void save();
	bool isEmpty() const;
	unsigned int getTimeNeeded() const;

private:
	struct Frame
	{
		Vec2f position;
		float angle;
	};

	std::string filename;
	bool record;
	std::vector<Frame> frames;
	size_t time;
	unsigned int timeNeeded;
};

#endif