#ifndef OBJ_POWERUP_H
#define OBJ_POWERUP_H

#include "GameObject.h"

class Obj_PowerUp : public GameObject
{
public:
	Obj_PowerUp( Level& level, const TiXmlElement* p_root );
	~Obj_PowerUp();

	std::string getType() const { return "PowerUp"; }

	void update();
	void render( RenderPass pass );
	void onCollision( GameObject* p_other, CollisionInfo& info );

	void setSubType( int subType )		{ type = subType; }
	int getSubType() const				{ return type; }
	void setReward( int reward )		{ points = reward; }
	int getReward() const				{ return points; }
	void setShieldDuration( float v )	{ shieldDuration = v; }
	float getShieldDuration() const		{ return shieldDuration; }

private:
	int type;
	bool dynamic;
	int points;
	float shieldDuration;
	Vec2i texCoords;
	SoundHandle sound;
	float t;
};

#endif