#ifndef OBJ_PROJECTILE_H
#define OBJ_PROJECTILE_H

#include "GameObject.h"

class Obj_Projectile : public GameObject
{
public:
	Obj_Projectile( Level& level, GameObject* p_owner, int type );
	~Obj_Projectile();

	std::string getType() const { return "Projectile"; }

	void update();
	void render( RenderPass pass );
	void onCollision( GameObject* p_other, CollisionInfo& info );

	void setTimeToLive( float timeToLive );
	float getTimeToLive() const;
	int getProjectileType() const;

	GameObject* getOwner() const { return p_owner; }

private:
	void burst( unsigned int numProjectiles, int projectileType);

	GameObject* p_owner;
	SimpleEmitter* p_fireEmitter;
	SimpleEmitter* p_smokeEmitter;
	int type;
	Vec2i texCoords;
	Vec2i sizeOnTexture;
	SoundHandle impactSound;
	float age;
	float damage;
	float damageVar;
	float timeToLive;
	Vec2f oldVelocity;
	bool bounce;
};

#endif