#ifndef OBJ_WALL_H
#define OBJ_WALL_H

#include "GameObject.h"
#include "Damagable.h"

class Obj_Wall : public GameObject, public Damagable
{
public:
	Obj_Wall( Level& level, const TiXmlElement* p_root );
	~Obj_Wall();

	std::string getType() const { return "Wall"; }

	void update();
	void render( RenderPass pass );

	bool reflectsLaser() const;

private:
	void updateCollisionBits();

	std::vector<Vec2f> vertices;
	std::string style;
	bool fill;
	bool close;
	float radius;
	float shift;
	bool dynamic;
	bool blockLaser;
	bool reflectLaser;
	int health;
	TextureHandle cracksTexture;
	float fade;
	unsigned int listID;
	bool oldVisible;
};

#endif