#ifndef SCRIPTOBJ_COUNTER
#define SCRIPTOBJ_COUNTER

#include "ScriptObject.h"

class ScriptObj_Counter : public ScriptObject
{
public:
	ScriptObj_Counter( Level& level, int displayMode, int direction, float duration, luabind::object onElapsed );
	~ScriptObj_Counter();

	std::string getType() const { return "Counter"; }

	void update();
	void render();

	int getDisplayMode() const { return displayMode; }
	void setDisplayMode( int v ) { displayMode = v; }
	int getDirection() const { return direction; }
	void setDirection( int v ) { direction = v; }
	float getDuration() const { return duration; }
	void setDuration( float v ) { duration = v; }
	luabind::object getOnElapsed() const { return onElapsed; }
	void setOnElapsed( luabind::object v ) { onElapsed = v; }
	float getTime() const { return time; }
	void setTime( float v ) { time = v; }
	bool isPaused() const { return paused; }
	void setPaused( bool v ) { paused = v; }
	const Vec4f& getColor() const { return color; }
	void setColor( const Vec4f& v ) { color = v; }
	int getNumBeeps() const { return numBeeps; }
	void setNumBeeps( int v ) { numBeeps = v; }

private:
	int displayMode;
	int direction;
	float duration;
	luabind::object onElapsed;
	float time;
	bool paused;
	Vec4f color;
	int numBeeps;
	int oldNumSecondsLeft;
};

#endif