#ifndef SCRIPTOBJECT_H
#define SCRIPTOBJECT_H

#include "Level.h"

class ScriptObject
{
public:
	ScriptObject( Level& level );
	virtual ~ScriptObject();

	// liefert den Typ dieses Objekts als String
	virtual std::string getType() const = 0;

	// aktualisiert das Objekt
	virtual void update();

	// rendert das Objekt
	virtual void render();

	// liefert true, wenn das Objekt vom Level gelscht werden soll
	bool isToBeDeleted() const;

	// lscht das Objekt
	void kill();

protected:
	// das zugehrige Levelobjekt
	Level& level;

	// Spielumgebung
	GameEnvironment& env;

	// Shortcut zum Video-Objekt
	Video& video;

private:
	// auf true setzen, damit das Objekt gelscht wird
	bool dead;
};

#endif