#include <PCH.h>
#include <Damagable.h>

Damagable::Damagable() : maxHealth( 100.0f ),
						 invincible( false )
{
	setHealth( maxHealth );
}

Damagable::~Damagable()
{
}

void Damagable::setHealth( float health )
{
	this->health = clamp( health, invincible ? this->health : 0.0f, maxHealth );
}

void Damagable::addHealth( float value )
{
	setHealth( health + value );
}

void Damagable::setMaxHealth( float maxHealth )
{
	this->maxHealth = max( 0.0f, maxHealth );
	setHealth( health );
}

float Damagable::getHealth() const
{
	return health;
}

float Damagable::getMaxHealth() const
{
	return maxHealth;
}