#include <PCH.h>
#include <Obj_EnergyNode.h>

Obj_EnergyNode::Obj_EnergyNode( Level& level,
								const TiXmlElement* p_root ) : GameObject( level, p_root, false )
{
	setMaxHealth( 5.0f );
	setHealth( 5.0f );
	setMaterial( "Metal" );

	// Der Energieknoten kann mit Objekten kollidieren, aber nicht mit Wnden.
	setCollisionBits( CB_STATIC | CB_OBJECT, ~CB_STATIC );

	addSegment( Vec2f( 0.0f, -1.0f ), Vec2f( 0.0f, 1.0f ), 0.75f );

	setBoundingCircle( Vec2f( 0.0f, 0.0f ), 2.5f );
}

Obj_EnergyNode::~Obj_EnergyNode()
{
}

void Obj_EnergyNode::update()
{
	GameObject::update();

	if( getHealth() <= 0.0f )
	{
		level.addPlayerScore( 100, getPosition() );
		explode( randInt( 10, 15 ), DT_ENERGYNODE, 1.5f );
		kill();
		return;
	}
}

void Obj_EnergyNode::render( RenderPass pass )
{
	if( pass == RP_SHADOW || pass == RP_OBJECT_1 )
	{
		// Sprite rendern
		glPushMatrix();
		setupGLMatrix();
		video.drawSprite( Vec2i( 448, 0 ), Vec2i( 64, 128 ), Vec2f( 2.0f, 4.0f ) );
		glPopMatrix();
	}
}