#include <PCH.h>
#include <Obj_StaticImage.h>

Obj_StaticImage::Obj_StaticImage( Level& level,
								  const TiXmlElement* p_root ) : GameObject( level, p_root, false )
{
	// Soll das Bild Schatten werfen?
	int drawShadows_ = 0;
	p_root->QueryIntAttribute( "drawShadows", &drawShadows_ );
	drawShadows = drawShadows_ ? true : false;

	// Texturdateiname lesen und Bild laden
	const TiXmlElement* p_image = p_root->FirstChildElement( "Image" );
	if( p_image )
	{
		const char* p_filename = p_image->GetText();
		if( p_filename )
		{
			std::string dir( "data\\" );

			int lookInLevelDir = 0;
			p_image->QueryIntAttribute( "lookInLevelDir", &lookInLevelDir );

			if( lookInLevelDir )
			{
				dir += std::string( "levels\\" ) + getPathDirectory( level.getFilename() ) + "\\";
			}

			image = env.engine.getTextureManager().get( dir + p_filename );
			texCoords = Vec2i( 0, 0 );
			sizeOnTexture = image->getSize();
		}

		// Texturkoordinaten lesen
		p_image->QueryIntAttribute( "u", &texCoords.u );
		p_image->QueryIntAttribute( "v", &texCoords.v );
		p_image->QueryIntAttribute( "sizeU", &sizeOnTexture.u );
		p_image->QueryIntAttribute( "sizeV", &sizeOnTexture.v );
	}

	// Gre lesen
	p_root->QueryFloatAttribute( "size", &size.x );
	size.y = size.x * static_cast<float>( sizeOnTexture.y ) / static_cast<float>( sizeOnTexture.x );
	p_root->QueryFloatAttribute( "sizeX", &size.x );
	p_root->QueryFloatAttribute( "sizeY", &size.x );

	setBoundingRect( -size / 2.0f, size / 2.0f );
}

Obj_StaticImage::~Obj_StaticImage()
{
}

void Obj_StaticImage::render( RenderPass pass )
{
	if( ( !drawShadows && pass == RP_BACKGROUND_2 ) ||
		( drawShadows && ( pass == RP_OBJECT_1 || pass == RP_SHADOW ) ) )
	{
		glPushMatrix();
		setupGLMatrix();

		// Bild rendern
		video.setTexture( image );
		video.drawSprite( texCoords, sizeOnTexture, size );

		glPopMatrix();
	}
}